%% Function that choses randomly (with roulette) what group the pile must join given the miscoverings. "candidates" are the candidates indexes
function [m] = rouletteOPPSP(miscoverings,candidates)

K=length(miscoverings);

if K==1
    m=1;
    return;
end

miscoverings=miscoverings(candidates);
total=sum(miscoverings);
int_probs=total-miscoverings;  % "integer probability"
if sum(int_probs)~=0
    probs=int_probs/sum(int_probs);
else     % it means that there's only one pile remaining
    probs=1;
end
ac=zeros(1,length(candidates));
ac(1)=probs(1);  % cumulative probability
if length(probs)>1
    for i=2:length(candidates)
        ac(i)=ac(i-1)+probs(i);
    end
end
random_val=rand();
for i=1:length(candidates)
    if ac(i)>=random_val
        m=candidates(i);
        break;
    end
end
end

