%% This function finds if summary piles are equal to any pile and returns a text with the results
function [text] = check_piles(pmj,yilij,ximli,weights,yilij_raw)

text = '';

raw = [];
for i = 1:length(yilij_raw)
    for li = 1:size(yilij_raw{i},1)
        raw = [raw;yilij_raw{i}(li,:)];
    end
end

K=size(pmj{1},1);
for m=1:K
    ci=size(yilij{1},1);
    equal_li=0;
    cover_sum=0;
    for li=1:ci
        if ximli{1}(m,li)==1
            cover_sum=cover_sum+weights{1}(li);
            if pmj{1}(m,:)==yilij{1}(li,:)
                equal_li=li;
            end
        end
    end
    if equal_li~=0
        for li = 1:size(raw,1)
            if isequal(yilij{1}(equal_li,:),raw(li,:))
                break;
            end
        end
        text = sprintf('%sSummary pile %d equals pile %d (appears %d times), and covers other %d piles (%d total).\n',text,m,li,weights{1}(equal_li),cover_sum-weights{1}(equal_li),cover_sum);
    else
        text = sprintf('%sSummary pile %d doesnt equal any pile, but covers %d piles.\n',text,m,cover_sum);
    end
end

end