%% This function finds if summary piles are equal to any pile and returns a text with the results. Piles from the same individual must be covered by different summay piles
function [text] = check_pilesOPPSP(pmj,yilij,ximli)

text = '';

K=size(pmj{1},1);
I = length(yilij);
ci=zeros(I,1);
for i = 1:I
    ci(i)=size(yilij{i},1);
end
for m=1:K
    cover_sum=0;
    equal_li=0;
    equal_i=0;
    for i = 1:I
        for li=1:ci(i)
            if ximli{i}(m,li)==1
                cover_sum=cover_sum+1;
                if equal_li==0
                    if pmj{1}(m,:)==yilij{i}(li,:)
                        equal_li=li;
                        equal_i=i;
                    end
                end
            end
        end
    end
    if equal_li~=0
        text = sprintf('%sSummary pile %d equals pile %d of individual %d, and covers a sum of %d piles.\n',text,m,equal_li,equal_i,cover_sum);
    else
        text = sprintf('%sSummary pile %d doesnt equal any pile, but covers %d piles.\n',text,m,cover_sum);
    end
end

end