%% This function displays a message above the log text
function [] = set_message(handles,msg,mode)
%% Inputs:
% handles: handles to GUI objects
% msg: text string
% mode (optional): 'normal' or 'error'

%%
if nargin == 2
    mode = 'normal';
end
if strcmp(mode,'clear')
    set(handles.sTmsg,'ForegroundColor',[0 0 0]);
    set(handles.sTmsg,'String','');
    drawnow
elseif strcmp(mode,'normal')
    set(handles.sTmsg,'ForegroundColor',[0 0 0]);
    set(handles.sTmsg,'String',msg);
    drawnow
elseif strcmp(mode,'error')
    set(handles.sTmsg,'ForegroundColor',[1 0 0]);
    set(handles.sTmsg,'String',msg);
    drawnow
else
    set(handles.sTmsg,'ForegroundColor',[0 0 0]);
    set(handles.sTmsg,'String',msg);
end
end

